// LVSelStateDlg.h : header file
//

#pragma once
#include "afxcmn.h"
#include "afxwin.h"

class CLVItemDataMgr;

// CLVSelStateDlg dialog
class CLVSelStateDlg : public CDialog
{
// Construction
public:
	CLVSelStateDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_LVSELSTATE_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON           m_hIcon;
    CListCtrl       m_ctlList;          // Virtual List Control
    CButton         m_btnCancel;        // Cancel btn control
    CButton         m_btnRetrieve;      // Retrieve btn control
    CString         m_sStatus;          // Status messages
    CImageList      m_ImageList;        // Image List
    CSpinButtonCtrl m_ctlMaxCountSpin;  // Spin control
    UINT            m_uMaxCount;        // Max LV Item count


    // Class that manages creation of CLVItemData objects
    // using a secondary thread.  Illustrates proper resource
    // locking when sharing a std::vector between threads
    CLVItemDataMgr  m_LVItemDataMgr;    

	// Generated message map functions
	virtual BOOL    OnInitDialog();
	afx_msg void    OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
    DECLARE_MESSAGE_MAP()

    //
    // Button handlers
    //
    afx_msg void OnBnClickedRetrieve();
    afx_msg void OnBnClickedCancel();
    
    //
    // List Control Message Overrides
    //

    // OnNMClick... - used to change check state
    afx_msg void OnNMClickList(NMHDR *pNMHDR, LRESULT *pResult);
    
    // OnLvnGetdisp... -- used for virtual List Control
    // asks the data associated with the LV Item
    // for text and image data.  This for fast filling/scrolling
    // the list control when dealing with a large number of items
    // (as compared to a non-virtual list control)
    afx_msg void OnLvnGetdispinfoList(NMHDR *pNMHDR, LRESULT *pResult);

    // Simple status text function
    void SetStatusText( LPCTSTR szText );
public:

};
